import { RESTORE_CHAT_HISTORY, 
        SEND_HISTORY_REQUEST } from './actionTypes'

import * as ActionStatuses from './actionStatuses'

export function restoreChatHistory(data) {
    return {
        type: RESTORE_CHAT_HISTORY,
        payload: data
    }
}

export function sendHistoryRequest(request, responseType, responseLoc, historyRetriever) {
    return (dispatch) => {
        dispatch(historyRequest(
            ActionStatuses.begin,
            request
        ));

        historyRetriever.getHistoryAsync(request).
            then((response) => {
                return response.json();
            }).then((data) => {
                dispatch(historyRequest(
                    ActionStatuses.processing,
                    {
                        stateLocation : responseLoc,
                        responseType,
                        response : data
                    }
                ));
            }).catch((err) => {
                dispatch(historyRequest(
                    ActionStatuses.error,
                    {
                        stateLocation : responseLoc,
                        response : err
                    }, 
                    true
                ));
            });
        
    }
}

export function receivedHistoryResponse(messages, stateLocation) {
    return {
        type : SEND_HISTORY_REQUEST,
        payload : { 
            messages, 
            stateLocation 
        },
        status : ActionStatuses.complete
    }
}

const historyRequest = (status, payload, error) => {
    return {
        type : SEND_HISTORY_REQUEST,
        status,
        payload,
        error
    }
}
