import watch from 'redux-watch'
import reducer from './reducers/index'
import * as Actions from './actions/actions'
import * as ActionStatuses from './actions/actionStatuses'
import GetHistoryRequestHandler from './nextit-request-handler-history'
import GetHistoryResponseHandler from './nextit-response-handler-history'

export default class InitializeGetHistory {
    constructor(settings) {
        this._settings = settings;
    }

    getReducer() {
        return reducer;
    }

    initialize(store) {
        this._store = store;

        let stateLocations = this._settings.stateLocations;

        initWatcher = watch(this.store.getState, stateLocations.Initialization.Base);

        this._store.subscribe(initWatcher(this.handleInitialize));
    }

    handleInitialize(newVal, oldVal, objectPath) {
        let data = {
            input : {
                messageType : this._settings.messageConstants.getHistoryMessageType,
                messageLimit : this._settings.History.messageLimit,
                includeRevertedEntries : this._settings.History.includeRevertedEntries
            },
            stateLocation : this._settings.stateLocations.History.stagedInput
        };

        this._store.dispatch(Actions.restoreChatHistory(data));
    }
    
    getRequestHandler() {
        return new GetHistoryRequestHandler(this._settings);
    }

    getResponseHandler() {
        return new GetHistoryResponseHandler(this._settings);
    }
}
