import * as Actions from './actions/actions'

export default class GetHistoryRequestHandler {
    constructor(almeApi, settings) {
        this._almeApi = almeApi;
        this._settings = settings;
    }

    initialize(store) {
        this._dispatch = store.dispatch;
    }

    handle(input) {
        if(!this.doesHandle(input)) return;

        let receivedResponseLoc = this._settings.stateLocations.Conversation.receivedResponse;

        let HistoryRequest = this._almeApi.dataTypes().HistoryRequestDetails;

        let request = new HistoryRequest(
            input.userId,
            input.sessionId,
            input.messageLimit,
            input.includeRevertedEntries
        );
        
        let responseType = this._settings.messageConstants.getHistoryRequest;

        this._dispatch(sendHistoryRequest(
            request,
            responseType,
            receivedResponseLoc,
            this._almeApi.historyRetriever()
        ));
    }

    doesHandle(input) {
        return input.messageType === this._settings.messageConstants.getHistoryRequest
    }

    
}
