import * as Actions from './actions/actions'

export default class GetHistoryResponseHandler {
    constructor(settings) {
        this._settings = settings;
    }

    initialize(store) {
        this._store = store;
    }

    process(response) {
        if(!this.doesHandle(response)) return;

        let responses = response.responses || [];
        let stateLocation = this._settings.History.Messages;

        let stagableResponses = responses.map(this.mapResponses).reduce(this.reduceResponses);

        this._store.dispatch(Actions.receivedHistoryResponse(stagableResponses, stateLocation));
    }

    mapResponses(value) {

        let userInput = {
            type : this._settings.messageConstants.userInputType,
            text : value.maskedInput,
            userDisplyName : value.userDisplayName
        };

        let almeResponse = {
            type : this._settings.messageConstants.almeResponseType,
            html : value.text,
            agentDisplayName : value.agentDisplayName
        };

        return [
            userInput,
            agentResponse
        ]
    }

    reduceResponses(prev, cur) {
        return prev.concat(cur);
    }

    doesHandle(response) {
        return response.responseType === this._settings.messageConstants.getHistoryRequest;
    }
}
