import { RESTORE_CHAT_HISTORY,
        SEND_HISTORY_REQUEST } from '../actions/actionTypes'
import * as ActionStatuses from '../actions/actionStatuses'

export default function reducer(state = {}, action) {
    let loc = {};
    let response = {}
    switch (action.type) {
      case RESTORE_CHAT_HISTORY:
        let newInput = action.payload.input;
        let stateLoc = action.payload.stateLocation;
        let newState = Object.assign({}, state[stateLoc], {
          input: newInput
        });

        return Object.assign({}, state, { [stateLoc] : newState });
      break;

      case SEND_HISTORY_REQUEST:
        switch (action.status) {
            case ActionStatuses.begin:
                //we reall don't care right now
            break;

            case ActionStatuses.processing:
                let responseLoc = action.payload.stateLocation;

                response = {
                    responses : action.payload.response,
                    responseType : action.payload.responseType
                };

                return Object.assign({}, state, {
                    [responseLoc] : response
                });
            break;

            case ActionStatuses.complete:
                loc = action.payload.stateLocation;
                let messages = action.payload.messages;

                let newMessages = state[loc].concat(messages);

                return Object.assign({}, state, {
                    [loc] : newMessages
                });
            break;

            case ActionStatuses.error:
                loc = action.payload.stateLocation;
                response = {
                    error : true,
                    message : action.payload.response
                };

                return Object.assign({}, state, {
                    [loc] : response
                });
            break;

            default:
                return state;
        }
      break;

      default:
        return state;
    }
}
