import test from 'ava';
import InitializeGetHistory from '../src/nextit-initialization-gethistory';

test.beforeEach(t => {
    t.context.mockSettings = {
        stateLocations : {
            History : {
                Base: "Conversation",
                stagedInput: "StagedInput",
                inputProcessing: "InputProcessing",
                processedInput: "ProcessedInput",
                recievedReponse: "RecievedResponse",
                responseProcessing: "ResponseProcessing",
                processedResponse: "ProcessedResponse"
            }
        }
    }

    t.context.mockState = (value) => {
        return {
            value
        }
    }
});

test('Module is defined', t => {
    t.plan(1);
    let module = new InitializeGetHistory(t.context.mockSettings);
    let type = typeof InitializeGetHistory;
    t.not(type, undefined, 'Module is undefined');
});

test("Module is a class, and returns new instance", t => {
  	t.notThrows(() => {new InitializeGetHistory(t.context.mockSettings)});
  	let instance = new InitializeGetHistory(t.context.mockSettings);
  	let type = typeof instance;
  	t.not(type, undefined, "Instance is undefined");
});

test("getReducer returns a single function", t => {
    let reducer = new InitializeGetHistory(t.context.mockSettings).getReducer();
    let type = typeof reducer;

    t.is(type, "function");
});

test("Reducer returns empty object on initialization", t => {
    let reducer = new InitializeGetHistory(t.context.mockSettings).getReducer();
    let newState = reducer(undefined, {type: test});

    t.not(newState, undefined);
});
