import test from 'ava';
import reducer from '../src/reducers/index';
import { RESTORE_CHAT_HISTORY } from '../src/actions/actionTypes';
import InitializeGetHistory from '../build/nextit-initialization-gethistory';

test("Reducer returns empty object on initialization", t => {
    let action = {
        type: 'something'
    };

    t.truthy(reducer(undefined, action));
});

test("Reducer reducer handles RESTORE_CHAT_HISTORY action", t => {
    let mockAction = {
        type: RESTORE_CHAT_HISTORY,
        payload: {
            input: "stuff and things",
            stateLocation: "dynamicLocation"
        }
    };

    let reducer = new InitializeGetHistory().getReducer();

    let newState = reducer(undefined, mockAction);

    t.is(newState.dynamicLocation.input, "stuff and things");
});
